diff --git a/bin/build.sh b/bin/build.sh
index 496d641757cd9d103ad061ffc3b527a3cf93efe7..fa0b3df3a92e033ca23f0ccabe218b230817f599 100755
--- a/bin/build.sh
+++ b/bin/build.sh
@@ -96,6 +96,7 @@ usage ()
     echo "               The flags always include -noinit -nositeinit"
     echo "    -R        Force recompiling the C runtime.  Normally, just runs make to "
     echo "               recompile anything that has changed."
+    echo "    -M opt    Additional flags to be passed to make."
     exit 1
 }
 
@@ -127,13 +128,17 @@ buildit ()
 	$TOOLDIR/clean-target.sh $CLEAN_FLAGS $TARGET || { echo "Failed: $TOOLDIR/clean-target.sh"; exit 1; }
 	time $BUILDWORLD $TARGET $OLDLISP $BOOT || { echo "Failed: $BUILDWORLD"; exit 1; }
 	if [ "$REBUILD_LISP" = "yes" ]; then
-	    $TOOLDIR/rebuild-lisp.sh $TARGET
+	    if [ -z $MFLAGS ]; then
+		$TOOLDIR/rebuild-lisp.sh $TARGET
+	    else
+		$TOOLDIR/rebuild-lisp.sh -M "$MFLAGS" $TARGET
+	    fi
 	else
 	    # Set the LANG to C.  For whatever reason, if I (rtoy) don't
 	    # do this on my openSuSE system, any messages from gcc are
 	    # basically garbled.  This should be harmless on other
 	    # systems.
-	    LANG=C $MAKE -C $TARGET/lisp $MAKE_TARGET || { echo "Failed: $MAKE -C $TARGET/lisp"; exit 1; }
+	    LANG=C $MAKE -C $TARGET/lisp $MFLAGS $MAKE_TARGET || { echo "Failed: $MAKE -C $TARGET/lisp"; exit 1; }
         fi
 
 	if [ "$BUILD_WORLD2" = "yes" ];
@@ -152,7 +157,7 @@ BUILDWORLD="$TOOLDIR/build-world.sh"
 BUILD_POT="yes"
 UPDATE_TRANS=
 
-while getopts "123PRo:b:v:uB:C:Ui:f:w:O:?" arg
+while getopts "123PRo:b:v:uB:C:Ui:f:w:O:M:?" arg
 do
     case $arg in
 	1) ENABLE2="no" ;;
@@ -172,6 +177,7 @@ do
         U) UPDATE_TRANS="yes";;
 	O) OLDLISPFLAGS="$OLDLISPFLAGS $OPTARG" ;;
         R) REBUILD_LISP="yes";;
+        M) MFLAGS="$OPTARG" ;;
 	\?) usage
 	    ;;
     esac